VERSION 5.00
Begin VB.UserControl SubForm 
   Alignable       =   -1  'True
   BackColor       =   &H80000018&
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   2820
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3285
   ControlContainer=   -1  'True
   ScaleHeight     =   2820
   ScaleWidth      =   3285
   ToolboxBitmap   =   "SubForm.ctx":0000
End
Attribute VB_Name = "SubForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' ===========================================================================
'Copyright  2001, Dan Mircea Fratila ( DanFratila@yahoo.com). All Rights Reserved.
'Author:Dan Mircea Fratila
' ===========================================================================
' FREE SOURCE CODE! - ENJOY.
' - Please report bugs to the author for incorporation into future releases
' - Don't sell this code.
' ===========================================================================

Private Const WM_MOVE = &H3
Private Const WM_SIZE = &H5

Private Type RECT
  left As Long
  top As Long
  right As Long
  bottom As Long
End Type

Private Type SIZE
  cX As Long
  cY As Long
End Type


Public Enum ScrollStyleConstants
  efsRegular = 0& 'FSB_REGULAR_MODE
  efsEncarta = 1& 'FSB_ENCARTA_MODE
  efsFlat = 2& 'FSB_FLAT_MODE
End Enum
Public Enum sfBorderStyle
  vbBSNone = 0
  vbFixedSingle = 1
End Enum


Private Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long

Private Declare Function MoveWindow Lib "user32" (ByVal hwnd As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long

Private WithEvents m_subForm As Form
Attribute m_subForm.VB_VarHelpID = -1
Private m_isOpen As Boolean

Private mSubFormSize As SIZE
Private mOffset As SIZE
Private m_IsScrolling As Boolean


Implements ISubclass
' ===========================================================================
'ISubclass
'Copyright  1998-1999, Steve McMahon ( steve@vbaccelerator.com). All Rights Reserved.
'Author: Steve McMahon (steve@vbaccelerator.com)
'www.vbaccelerator.com
' ===========================================================================

'Default Property Values:

Const m_def_ScrollBarStyle = 0
'Property Variables:

Private WithEvents m_cScroll As cScrollBars
Attribute m_cScroll.VB_VarHelpID = -1
Dim m_ScrollBarStyle As ScrollStyleConstants
' ===========================================================================
'cScrollBars
' Copyright  1998 Steve McMahon (steve@dogma.demon.co.uk)
' Visit vbAccelerator - free, advanced source code for VB programmers.
'     http://vbaccelerator.com
' ===========================================================================
'Event Declarations:

Event AfterAttach(ByVal FormName As String, ByVal FormWidth As Long, ByVal FormHeight As Long)
Event Scroll(ByVal isHorizontalBar As Boolean)
Event Change(ByVal isHorizontalBar As Boolean)


Public Sub AttachForm(frm As Object)
  DetachForm
  Set m_subForm = frm
  SetParent m_subForm.hwnd, UserControl.hwnd
  
  AttachMessage Me, m_subForm.hwnd, WM_MOVE
  AttachMessage Me, m_subForm.hwnd, WM_SIZE

  AttachMessage Me, UserControl.hwnd, WM_SIZE

  
  m_subForm.Show
  
  
  Set m_cScroll = New cScrollBars
  m_cScroll.Create UserControl.hwnd
  m_cScroll.Style = m_ScrollBarStyle
  
  m_isOpen = True
  
  CalcSubFormSize
  CalcScrollSize
  SetSubFormPoz
  
Dim frmName As String, frmWith As Long, frmHeight As Long
  frmName = m_subForm.Name
  frmWith = m_subForm.Width
  frmHeight = m_subForm.Height
  
  RaiseEvent AfterAttach(frmName, frmWith, frmHeight)
  End Sub
Public Sub DetachForm()
If Not m_isOpen Then Exit Sub
  DetachMessage Me, m_subForm.hwnd, WM_MOVE
  DetachMessage Me, m_subForm.hwnd, WM_SIZE
  
  DetachMessage Me, UserControl.hwnd, WM_SIZE
  
  mOffset.cX = 0
  mOffset.cY = 0
  
  mSubFormSize.cX = 0
  mSubFormSize.cY = 0
  
  m_cScroll.Visible(efsHorizontal) = False
  m_cScroll.Visible(efsVertical) = False
  
  Set m_cScroll = Nothing
  
  m_isOpen = False
  Unload m_subForm
  
  Set m_subForm = Nothing

End Sub

Private Sub m_cScroll_Change(eBar As EFSScrollBarConstants)
Dim bIsHoriz As Boolean
  If eBar = efsHorizontal Then
    bIsHoriz = True
  Else
    bIsHoriz = False
  End If
  
   If (m_cScroll.Visible(eBar)) Then
      If (eBar = efsHorizontal) Then
         mOffset.cX = -m_cScroll.Value(eBar)
      Else
         mOffset.cY = -m_cScroll.Value(eBar)
      End If
  Else
    mOffset.cX = 0
    mOffset.cY = 0
   End If
  m_IsScrolling = True
    SetSubFormPoz
  m_IsScrolling = False
  RaiseEvent Change(bIsHoriz)
  
End Sub

Private Sub m_cScroll_Scroll(eBar As EFSScrollBarConstants)
  m_cScroll_Change eBar
End Sub

Private Sub m_subForm_QueryUnload(Cancel As Integer, UnloadMode As Integer)
  Cancel = m_isOpen
End Sub


Private Sub UserControl_EnterFocus()
  If m_isOpen Then m_subForm.SetFocus
End Sub


Private Sub UserControl_Terminate()
  Set m_cScroll = Nothing
  Set m_subForm = Nothing
End Sub
Private Sub CalcSubFormSize()
Dim rc As RECT
  GetWindowRect m_subForm.hwnd, rc
  With rc
    mSubFormSize.cX = .right - .left
    mSubFormSize.cY = .bottom - .top
  End With
End Sub
Private Sub CalcScrollSize()
If Not m_isOpen Then Exit Sub

Dim lHeight As Long
Dim lWidth As Long
Dim lProportion As Long

Dim rcParent As RECT
  GetClientRect UserControl.hwnd, rcParent
  
   lHeight = mSubFormSize.cY - rcParent.bottom + 15
   If (lHeight > 0) Then
      lProportion = lHeight / mSubFormSize.cY + 1
      m_cScroll.LargeChange(efsVertical) = lHeight \ lProportion
      m_cScroll.Max(efsVertical) = lHeight
      m_cScroll.Visible(efsVertical) = True
   Else
      m_cScroll.Visible(efsVertical) = False
   End If
   
   lWidth = mSubFormSize.cX - rcParent.right + 15
   If (lWidth > 0) Then
      lProportion = lWidth \ mSubFormSize.cX + 1
      m_cScroll.LargeChange(efsHorizontal) = lWidth \ lProportion
      m_cScroll.Max(efsHorizontal) = lWidth
      m_cScroll.Visible(efsHorizontal) = True
   Else
      m_cScroll.Visible(efsHorizontal) = False
   End If
   

End Sub

Private Sub SetSubFormPoz()
If Not m_isOpen Then Exit Sub
  MoveWindow m_subForm.hwnd, mOffset.cX, mOffset.cY, mSubFormSize.cX, mSubFormSize.cY, 1
End Sub
Private Property Let ISubclass_MsgResponse(ByVal RHS As EMsgResponse) 'SSubTimer6.EMsgResponse)
'

End Property

Private Property Get ISubclass_MsgResponse() As EMsgResponse 'SSubTimer6.EMsgResponse
'

End Property
Private Function ISubclass_WindowProc(ByVal hwnd As Long, ByVal iMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'
  Select Case hwnd
  Case m_subForm.hwnd
    Select Case iMsg
      Case WM_MOVE
        If Not m_IsScrolling Then SetSubFormPoz
      Case WM_SIZE
        CalcSubFormSize
        CalcScrollSize
        SetSubFormPoz
    End Select
  Case UserControl.hwnd
    Select Case iMsg
      Case WM_SIZE
        CalcSubFormSize
        CalcScrollSize
        
        mOffset.cX = 0
        mOffset.cY = 0

        SetSubFormPoz
    End Select
  End Select
End Function


'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=8,0,0,0
Public Property Get ScrollBarStyle() As ScrollStyleConstants
Attribute ScrollBarStyle.VB_Description = "see Steve McMahon (steve@dogma.demon.co.uk) cScrollBars"
Attribute ScrollBarStyle.VB_ProcData.VB_Invoke_Property = ";Misc"
  ScrollBarStyle = m_ScrollBarStyle
End Property

Public Property Let ScrollBarStyle(ByVal New_ScrollBarStyle As ScrollStyleConstants)
  m_ScrollBarStyle = New_ScrollBarStyle
  If m_isOpen Then m_cScroll.Style = m_ScrollBarStyle

  PropertyChanged "ScrollBarStyle"
End Property

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
  m_ScrollBarStyle = m_def_ScrollBarStyle
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  m_ScrollBarStyle = PropBag.ReadProperty("ScrollBarStyle", m_def_ScrollBarStyle)
  UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
  UserControl.BackColor = PropBag.ReadProperty("BackColor", &H80000018)
  UserControl.BorderStyle = PropBag.ReadProperty("BorderStyle", 0)
  Set Picture = PropBag.ReadProperty("Picture", Nothing)
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
  Call PropBag.WriteProperty("ScrollBarStyle", m_ScrollBarStyle, m_def_ScrollBarStyle)
  Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
  Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H80000018)
  Call PropBag.WriteProperty("BorderStyle", UserControl.BorderStyle, 0)

  Call PropBag.WriteProperty("Picture", Picture, Nothing)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
  Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
  UserControl.Enabled() = New_Enabled
  PropertyChanged "Enabled"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
  BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
  UserControl.BackColor() = New_BackColor
  PropertyChanged "BackColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BorderStyle
Public Property Get BorderStyle() As sfBorderStyle
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
  BorderStyle = UserControl.BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As sfBorderStyle)
  UserControl.BorderStyle() = New_BorderStyle
  PropertyChanged "BorderStyle"
End Property


Public Function isEmpty() As Boolean
  isEmpty = Not m_isOpen
End Function


'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Picture
Public Property Get Picture() As Picture
Attribute Picture.VB_Description = "Returns/sets a graphic to be displayed in a control."
  Set Picture = UserControl.Picture
End Property

Public Property Set Picture(ByVal New_Picture As Picture)
  Set UserControl.Picture = New_Picture
  PropertyChanged "Picture"
End Property

